﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Sample_MultiColumnSort
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        
//SortDir
public enum SortDir
{
    None,
    Asc,
    Desc
}
        
private Bitmap _sortup;
private Bitmap _sortdn;
private static string sortCondition = string.Empty;

private void Form1_Load(object sender, EventArgs e)
{
    OleDbConnection1.ConnectionString = GetModifiedConnectionString(this.OleDbConnection1.ConnectionString);
    OleDbDataAdapter1.Fill(this.dataSet11);
    C1TrueDBGrid1.DataSource = this.dataSet11.Tables[0].DefaultView;
    // we're going to handle the sorting ourselves in the grids headclick event
    this.C1TrueDBGrid1.AllowSort = false;

    foreach (C1.Win.C1TrueDBGrid.C1DisplayColumn dc in C1TrueDBGrid1.Splits[0].DisplayColumns)
    {
	    // make the column headers act like buttons
	    dc.ButtonHeader = true;
	    // default sort order
	    dc.DataColumn.Tag = SortDir.None;
    }
    _sortdn = new Bitmap("..//..//SortDn.bmp");
    _sortup = new Bitmap("..//..//SortUp.bmp");
    _sortdn.MakeTransparent(Color.White);
    _sortup.MakeTransparent(Color.White);


}
// my own custom sorting when a column header is pressed 
private void C1TrueDBGrid1_HeadClick(object sender, C1.Win.C1TrueDBGrid.ColEventArgs e)
{
    // get the display column that was clicked
    {
        C1.Win.C1TrueDBGrid.C1DisplayColumn dc = this.C1TrueDBGrid1.Splits[0].DisplayColumns[e.ColIndex];
        // new sort order
        SortDir newsort = (SortDir)dc.DataColumn.Tag;
        switch (newsort)
        {
            case SortDir.None:
                newsort = SortDir.Asc;
                dc.HeadingStyle.ForegroundImage = this._sortup; //update image
                break;

            case SortDir.Asc:
                newsort = SortDir.Desc;
                dc.HeadingStyle.ForegroundImage = this._sortdn; //update image
                break;

            case SortDir.Desc:
                newsort = SortDir.None;
                dc.HeadingStyle.ForegroundImage = null;
                break;
        }

        // indicators go to the right of text
        dc.HeadingStyle.ForeGroundPicturePosition = C1.Win.C1TrueDBGrid.ForeGroundPicturePositionEnum.RightOfText;

        // save the sort state
        dc.DataColumn.Tag = newsort;

        //find if data field already has a sort criteria in existing sortCondition
        int posOfFieldName = sortCondition.IndexOf(dc.DataColumn.DataField);

        if (posOfFieldName == -1)
        {
            //if data field is not found and doesn't have an existing sort criteria
            if (sortCondition == string.Empty)
            {
                sortCondition = dc.DataColumn.DataField + " ";
            }
            else
            {
                sortCondition += "," + dc.DataColumn.DataField + " ";
            }
            sortCondition += dc.DataColumn.Tag.Equals(SortDir.Desc) ? "DESC " : "ASC ";
        }
        else
        {
            int startPosOfFirstSpace = sortCondition.IndexOf(" ", posOfFieldName + 1);
            int startPosOfSecondSpace = sortCondition.IndexOf(" ", startPosOfFirstSpace + 1);
            sortCondition = sortCondition.Remove(posOfFieldName, startPosOfSecondSpace - posOfFieldName + 1);
            if (newsort != SortDir.None)
            {
                sortCondition = sortCondition.Insert(posOfFieldName, dc.DataColumn.DataField.ToString() + " " + (dc.DataColumn.Tag.Equals(SortDir.Desc) ? "DESC " : "ASC "));
            }
            if (posOfFieldName > 0 && sortCondition.Length == posOfFieldName)
            {
                //if there is no field ahead then remove the previous comma also
                sortCondition = sortCondition.Remove(posOfFieldName - 1, 1);

            }
            else if (sortCondition != string.Empty && sortCondition.Substring(posOfFieldName, 1) == ",")
            {
                if (posOfFieldName > 0)
                {
                    sortCondition = sortCondition.Remove(posOfFieldName, 1);
                }
                else if (posOfFieldName == 0)
                {
                    sortCondition = sortCondition.Remove(posOfFieldName, 1);
                }
            }
        }

        // sort the grid
        this.dataSet11.Tables[0].DefaultView.Sort = sortCondition;
        this.Text = "C1TrueDbGrid Sort Condition: " + (sortCondition!=""?sortCondition: "None");
    }
}
private string GetModifiedConnectionString(string connstring)
{
    int dataSource = connstring.IndexOf("Data Source=", 0, StringComparison.OrdinalIgnoreCase);
    int dataSourceEnd = connstring.LastIndexOf("\\", connstring.IndexOf(";", dataSource));
    connstring = connstring.Substring(0, dataSource) + "Data Source=" + Environment.GetFolderPath(Environment.SpecialFolder.Personal) + "\\ComponentOne Samples\\Common" + connstring.Substring(dataSourceEnd);
    return connstring;
}

    }
}
